<?php
/*
Plugin Name: Amazon Einzeltitellink
Plugin URI:http://www.diewebmaster.it/amazon-einzeltitellinks-plugin-wordpress/
Description: Dieses Plugin erm&ouml;glicht die einfache Integration von Amazon Einzeltitellinks mit Text und Grafik.
Author: Dietmar Mitterer-Zublasing
Author URI: http://www.compusol.it/
Version: 1.3-beta
License: This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

Copyright 2008 Compusol des P.I. Mitterer-Zublasing Dietmar

Achtung ich &uuml;berneheme keine Haftung wenn durch dein Einsatz dieses Plugins Sch&auml;den finanzieller oder ideeller oder jeglicher anderer Art entstehen. Der Einsatz dieses Plugin erfolgt auf eigene Gefahr!

Installationshinweise siehe: http://www.diewebmaster.it/amazon-einzeltitellinks-plugin-wordpress/


*/

// Replace amazon Tags in Content with Amazon Links



function amazonContent($inhalt)
{
	$spos=0;
	$epos=0;
	
	$neuer_inhalt=$inhalt;
	
	while($spos=strpos($neuer_inhalt, '[aartikel]'))		// find each amazon tag
	{
		$epos=strpos($neuer_inhalt, '[/aartikel]');
		
		if($spos>0 & $epos>0)
		{
			$sub=substr($neuer_inhalt, $spos, $epos-$spos);	// extract the begin tag and parameters from contents
			$sub=str_replace('[aartikel]', '', $sub);	// remove the begin tag

			list($myASIN,$myFloat,$Partner_ID_Element)=split(":", $sub);	

			// set default values for missing parameters
			if(($myFloat!='left') && ($myFloat!='right')) $myFloat='none';

                        $Partner_ID="compusol-21"; 
                        if(get_option('amazon_PartnerID')!='') $Partner_ID=get_option('amazon_PartnerID');
			if($Partner_ID_Element!='') $Partner_ID=$Partner_ID_Element; 


			$amazon_einzeltitel_links=get_option('amazon_einzeltitel_links');
			if($amazon_einzeltitel_links=='') $amazon_einzeltitel_links="float:left; width:120px; margin-right:10px; height:240px; background-color:#FFFFFF; border:1px solid #000000;";

	 		$amazon_einzeltitel_rechts=get_option('amazon_einzeltitel_rechts');
                           if($amazon_einzeltitel_rechts=='') $amazon_einzeltitel_rechts="float:right; width:120px; margin-left:10px; height:240px; background-color:#FFFFFF; border:1px solid #000000;";

			$amazon_einzeltitel_none=get_option('amazon_einzeltitel_none');
                           if($amazon_einzeltitel_none=='') $amazon_einzeltitel_none="width:100%; height:240px; background-color:#FFFFFF; border:1px solid #000000;";

                           $amazon_einzeltitel_link=get_option('amazon_einzeltitel_link');
			if($amazon_einzeltitel_link=='') $amazon_einzeltitel_link="_blank";
                           
                           $amazon_einzeltitel_grafikgroesse=get_option('amazon_einzeltitel_grafikgroesse');
			if($amazon_einzeltitel_grafikgroesse=='') $amazon_einzeltitel_grafikgroesse="2";

                           $amazon_einzeltitel_preise=get_option('amazon_einzeltitel_preise');
			if($amazon_einzeltitel_preise=='') $amazon_einzeltitel_preise="";

                           $amazon_einzeltitel_textfarbe=get_option('amazon_einzeltitel_textfarbe');
			if($amazon_einzeltitel_textfarbe=='') $amazon_einzeltitel_textfarbe="000000";

                           $amazon_einzeltitel_linkfarbe=get_option('amazon_einzeltitel_linkfarbe');
			if($amazon_einzeltitel_linkfarbe=='') $amazon_einzeltitel_linkfarbe="0000FF";

                           $amazon_einzeltitel_art=get_option('amazon_einzeltitel_art');
			if($amazon_einzeltitel_art=='') $amazon_einzeltitel_art="8";

			// build the link based on the ad type
			
			//alte URL
			//$src='http://rcm-de.amazon.de/e/cm?t='.$Partner_ID.'&amp;o=3&amp;p='.$amazon_einzeltitel_art.'&amp;l=as1&amp;ASINs='.$myASIN.'&amp;fc1='.$amazon_einzeltitel_textfarbe.'&amp;IS'.$amazon_einzeltitel_grafikgroesse.'=1&amp;lt1='.$amazon_einzeltitel_link.'&amp;lc1='.$amazon_einzeltitel_linkfarbe.'&amp;bc1=transparent&amp;bg1=transparent&amp;f=ifr'.$amazon_einzeltitel_preise;

			//Neue URL
			//Welche bedeutung hat linkId ??? Ist ncoh zu klären. die linkID müsste noch einegfügt werden, sodass die URL exakt den URLs wie sie der Amazon Linkgenerator erstellt entspricht
			$src='http://ws-eu.amazon-adsystem.com/widgets/q?ServiceVersion=20070822&OneJS=1&Operation=GetAdHtml&MarketPlace=DE&source=ac&ref=tf_til&ad_type=product_link&tracking_id='.$Partner_ID.'&marketplace=amazon&region=DE&placement='.$myASIN.'&asins='.$myASIN.'&show_border=true&link_opens_in_new_window=true&price_color='.$amazon_einzeltitel_linkfarbe.'&title_color='.$amazon_einzeltitel_textfarbe.'&bg_color=FFFFFF';	
			
			switch($myFloat)
			{
				case 'left':
					$link = '<iframe scrolling="no" frameBorder="0" src="'.$src.'" marginheight="0" marginwidth="0" style="'.$amazon_einzeltitel_links.'"></iframe>';
					break;					
				case 'right':
					$link = '<iframe scrolling="no" frameBorder="0" src="'.$src.'" marginheight="0" marginwidth="0" style="'.$amazon_einzeltitel_rechts.'"></iframe>';
					break;	
				case 'none':
					$link = '<iframe scrolling="no" frameBorder="0" src="'.$src.'" marginheight="0" marginwidth="0" style="'.$amazon_einzeltitel_none.'"></iframe>';
					break;						
			}
			$neuer_inhalt=str_replace('[aartikel]'.$sub.'[/aartikel]', $link, $neuer_inhalt);
		}
	}
	return $neuer_inhalt;
}

// Admin Options Page
function amazonOptionsPage()
{
	if(isset($_POST['amazonUpdate']))
	{
		$Partner_ID=$_POST["BenutzerID"];
		$amazon_einzeltitel_links=$_POST["amazon_einzeltitel_links_name"];
		$amazon_einzeltitel_rechts=$_POST["amazon_einzeltitel_rechts_name"];
		$amazon_einzeltitel_none=$_POST["amazon_einzeltitel_none_name"];
		$amazon_einzeltitel_link=$_POST["amazon_einzeltitel_link_name"];
		$amazon_einzeltitel_grafikgroesse=$_POST["amazon_einzeltitel_grafikgroesse_name"];
		$amazon_einzeltitel_preise=$_POST["amazon_einzeltitel_preise_name"];
		$amazon_einzeltitel_textfarbe=$_POST["amazon_einzeltitel_textfarbe_name"];
		$amazon_einzeltitel_linkfarbe=$_POST["amazon_einzeltitel_linkfarbe_name"];
		$amazon_einzeltitel_art=$_POST["amazon_einzeltitel_art_name"];
		
		update_option('amazon_PartnerID', $Partner_ID);
		update_option('amazon_einzeltitel_links', $amazon_einzeltitel_links);
		update_option('amazon_einzeltitel_rechts', $amazon_einzeltitel_rechts);		
		update_option('amazon_einzeltitel_none', $amazon_einzeltitel_none);
		update_option('amazon_einzeltitel_link', $amazon_einzeltitel_link);	
		update_option('amazon_einzeltitel_grafikgroesse', $amazon_einzeltitel_grafikgroesse);
		update_option('amazon_einzeltitel_preise', $amazon_einzeltitel_preise);	
		update_option('amazon_einzeltitel_textfarbe', $amazon_einzeltitel_textfarbe);
		update_option('amazon_einzeltitel_linkfarbe', $amazon_einzeltitel_linkfarbe);	
		update_option('amazon_einzeltitel_art', $amazon_einzeltitel_art);			
?>
<div class="updated fade" id="message" style="background-color: rgb(207, 235, 247);"><p><strong>Options saved.</strong></p></div>
<?php
	}
	else
	{
		$Partner_ID=get_option('amazon_PartnerID');
		$amazon_einzeltitel_links=get_option('amazon_einzeltitel_links');
		$amazon_einzeltitel_rechts=get_option('amazon_einzeltitel_rechts');
		$amazon_einzeltitel_none=get_option('amazon_einzeltitel_none');
		$amazon_einzeltitel_link=get_option('amazon_einzeltitel_link');		
		$amazon_einzeltitel_grafikgroesse=get_option('amazon_einzeltitel_grafikgroesse');
		$amazon_einzeltitel_preise=get_option('amazon_einzeltitel_preise');
		$amazon_einzeltitel_textfarbe=get_option('amazon_einzeltitel_textfarbe');
		$amazon_einzeltitel_linkfarbe=get_option('amazon_einzeltitel_linkfarbe');
		$amazon_einzeltitel_art=get_option('amazon_einzeltitel_art');	
	}

?>
	<div class="wrap">
		<h2>amazon</h2>
		<form method="POST">
			<table class="optiontable">
				<tr valign="top">
					<th>PartnerID</th>
				  <td><input id="BenutzerID" name="BenutzerID" type="text" value="<?php echo $Partner_ID; ?>"><br>
					Die Partner ID bekommst du indem du dich unter https://partnernet.amazon.de anmeldest! Achtung, wenn du dieses Feld leer l&auml;sst, dann wird die Partner ID <strong>compusol-21</strong> eingesetzt und die Verkaufsprovisionen werden mir gutgeschrieben!</td>
				</tr>
				<tr valign="top">
					<th>Style f&uuml;r Float Links</th>
					<td><input name="amazon_einzeltitel_links_name" type="text" id="amazon_einzeltitel_links_name" value="<?php echo $amazon_einzeltitel_links; ?>" size="80">
					<br>
					CSS Anweisungen f&uuml;r Einzeltitellink der links gefloatet werden soll.  Du kennst dich nicht mit CSS aus? Kein Problem! Lasse das Feld leer. Es wird dann diese Anweisung: <strong>float:left; width:120px; margin-right:10px; height:240px; background-color:#FFFFFF; border:1px solid #000000;</strong> verwendet.</td>
			  	</tr>                
				<tr valign="top">
					<th>Style f&uuml;r Float Rechts</th>
					<td><input name="amazon_einzeltitel_rechts_name" type="text" id="amazon_einzeltitel_rechts_name" value="<?php echo $amazon_einzeltitel_rechts; ?>" size="80">
					<br>
					CSS Anweisungen f&uuml;r Einzeltitellink der rechts gefloatet werden soll.  Du kennst dich nicht mit CSS aus? Kein Problem! Lasse das Feld leer. Es wird dann diese Anweisung: <strong>float:right; width:120px; margin-left:10px; height:240px; background-color:#FFFFFF; border:1px solid #000000;</strong> verwendet.</td>
			  	</tr>   
				<tr valign="top">
					<th>Style f&uuml;r kein Float</th>
					<td><input name="amazon_einzeltitel_none_name" type="text" id="amazon_einzeltitel_none_name" value="<?php echo $amazon_einzeltitel_none; ?>" size="80">
					<br>
					CSS Anweisungen f&uuml;r Einzeltitellink der nicht gefloatet werden soll.  Du kennst dich nicht mit CSS aus? Kein Problem! Lasse das Feld leer. Es wird dann diese Anweisung: <strong>width:100%; height:240px; background-color:#FFFFFF; border:1px solid #000000;</strong> verwendet.</td>
			  	</tr>                  


				<tr valign="top">
					<th>Link in neuem Fenster?</th>
					<td><input id="amazon_einzeltitel_link_name" name="amazon_einzeltitel_link_name" type="text" value="<?php echo $amazon_einzeltitel_link; ?>"><br>
					Schreibe hier <strong>_blank</strong> oder <strong>_top</strong> hinein. Wenn du das Feld leer l&auml;sst, wird _blank verwendet.</td>
			  	</tr>  
				<tr valign="top">
					<th>Gr&ouml;&szlig;e der Grafik</th>
					<td><input id="amazon_einzeltitel_grafikgroesse_name" name="amazon_einzeltitel_grafikgroesse_name" type="text" value="<?php echo $amazon_einzeltitel_grafikgroesse; ?>"><br>
					Schreibe hier <strong>1</strong> (klein) oder <strong>2</strong> (gro&szlig;) hinein. Wenn du das Feld leer l&auml;sst, wird 2 verwendet.</td>
			  	</tr>  
				<tr valign="top">
					<th>Preise</th>
					<td><input id="amazon_einzeltitel_preise_name" name="amazon_einzeltitel_preise_name" type="text" value="<?php echo $amazon_einzeltitel_preise; ?>"><br>
					Lasse das Feld leer dann werden alle Preise angezeigt. Schreibe die Zeichenfolge <strong>&amp;nou=1</strong> hiein damit nur neue Preise angezeigt werden oder schreibe die Zeichenfolge   <strong>&amp;npa=1</strong> hinein damit keine  Preise angezeigt werden.</td>
			  	</tr>  
				<tr valign="top">
					<th>Textfarbe</th>
				  <td><input id="amazon_einzeltitel_textfarbe_name" name="amazon_einzeltitel_textfarbe_name" type="text" value="<?php echo $amazon_einzeltitel_textfarbe; ?>"><br>
					Schreibe hier den Hexadezimalcode ohne # f&uuml;r die Textfarbe hinein, also z.B. <strong>000000</strong> f&uuml;r Schwarz. Wenn du das Feld leer l&auml;sst, wird 000000 verwendet.</td>
			  	</tr>  
				<tr valign="top">
					<th>Linkfarbe</th>
				  <td><input id="amazon_einzeltitel_linkfarbe_name" name="amazon_einzeltitel_linkfarbe_name" type="text" value="<?php echo $amazon_einzeltitel_linkfarbe; ?>"><br>
					Schreibe hier den hecadezimalcode ohne # f&uuml;r die Textfarbe hinein, also z.B. <strong>0000FF</strong> f&uuml;r Blau.Wenn du das Feld leer l&auml;sst, wird 0000FF verwendet.</td>
			  	</tr>  
				<tr valign="top">
					<th>Art</th>
				  <td><input id="amazon_einzeltitel_art_name" name="amazon_einzeltitel_art_name" type="text" value="<?php echo $amazon_einzeltitel_art; ?>"><br>
					Schreibe hier <strong>8</strong> hinein. Auf eigene Verantwortung kannst du auch  <strong>6</strong> probieren. Dadurch wird die Grafik nicht angezeigt. Achtung das ist keine von Amazon dokumentierte Funktion, darum musst du selbst wissen was du machst! Wenn du das Feld leer l&auml;sst, wird 8 verwendet.</td>
			  	</tr>                                                   
                                                                                 




				<tr valign="top">
					<td>&nbsp;</td>
					<td><input name="amazonUpdate" type="submit" value="Speichern"></td>
				</tr>
			</table>
		</form>
		<h3>Einbindung des Amazon Einzeltitel Links</h3>
		<p>Um den Amazon Einzeltitel-Link in deinen Weblog einzubinden, musst du folgenden Tag in deinem Wordpressartikel eingeben:</p>
		<code>[aartikel]myASIN:myFloat:Partner_ID[/aartikel]</code>
		<p>wobei die beiden Parameter <strong>myFloat</strong> und <strong>Partner_ID</strong> optinal sind...</p>
<ul>
			<li><b>myASIN:</b> Hier musst du die ISBN Nummer oder ASIN Nummer des Amazon Artikel eingeben.</li>
			<li><b>myFloat:</b> Hier kannst du <b>left</b> oder <b>right</b> angeben oder den Parameter weglassen.  Dadurch bestimmst du ob der Amazon Artikel nach links, rechts oder nicht gefloatet werden soll.</li>
			<li><b>Partner_ID:</b> Wenn sich die gew&uuml;nschte Partner_ID von der in den Einstellungen eingegebenen Partner_ID unterscheiden soll, kannst du sie mit diesem Parameter angeben.</li>
</ul>			
<p></p>
		<h4>Beispiele</h4>

		<p>1. Einzelartikel Link ohne Float eingeben</p>
		<code>[aartikel]3835402617[/aartikel]</code>
		<p>Dadurch wird der Einzeltitellink mit der ASIN 3835402617 eingef&uuml;gt. Es findet keine Textumfluss statt.</p><hr>
		

		
		<p>2. Einzelartikellink mit Float eingeben</p>
		<code>[aartikel]3835402617:left[/aartikel]</code>
		<p>Dadurch wird der Einzeltitellink mit der ASIN 3835402617 eingef&uuml;gt. Es findet ein Textumfluss float:left statt.</p><hr>

		<p>3. Einzelartikellink mit Float und anderer Partner_IDeingeben</p>
		<code>[aartikel]3835402617:left:compusol-21[/aartikel]</code>
		<p>Dadurch wird der Einzeltitellink mit der ASIN 3835402617 eingef&uuml;gt. Es findet ein Textumfluss float:left statt. Es wird die Partner-ID compusol-21 verwendet, auch wenn in den Einstellungen eine andere Partner ID eingegeben wurde.</p><hr>

		

		
	</div>
    
    
    
	<div class="wrap">
		<h2>Weitere Informationen</h2>
		<p>Eventuelle Updates findest du hier:  <a href="http://www.diewebmaster.it/amazon-einzeltitellinks-plugin-wordpress/" target="_blank">http://www.diewebmaster.it/amazon-einzeltitellinks-plugin-wordpress/</a>.<p>
		<p>Die Homepage des Autors findest du unter: <a href="http://www.compusol.it" target="_blank">www.compusol.it</a></p>
	</div>
<?php
}

// Add Options Page
function amazonAdminSetup()
{
	add_options_page('Amazon Einzeltitel', 'Amazon Einzeltitel', 8, basename(__FILE__), 'amazonOptionsPage');	
}

// Load amazon Actions
if (function_exists('add_action'))
{
	add_action('the_content', 'amazonContent');
	add_action('admin_menu', 'amazonAdminSetup');
}

?>